<template>
    <div class="album">
        <a v-if="$route.query.hasOwnProperty('from')"
           :href="$route.query.from" class="back-button">&lt; zurück</a>
        <router-link v-else
                :to="{ name: 'albums' }" tag="a" class="back-button">&lt; zurück</router-link>
        <br><br>

        <h3 class="album__title">
            {{title}} - {{date}}
        </h3>

        <!--
        Flickr Album: <a :href="flickr.url" target="_blank">{{flickr.url}}</a>
        <br><br>
        -->

        <router-link :to="{ name: 'album-img', params: { img: idx+1 } }" tag="a"
           v-for="(image, idx) in images" :key="image.id"
           class="fancybox album__link"
           :data-fancybox-group="id"
           :href="image.url">
            <img class="album__img"
                 :alt="image.title"
                 :src="image.thumbUrl">
        </router-link>

        <p class="album__credits" v-html="credits"></p>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                id: this.$route.params.id,
                date: this.$store.state.lastAlbum.date,
                title: this.$store.state.lastAlbum.title,
                images: this.$store.state.lastAlbum.images,
                credits: this.$store.state.lastAlbum.credits,
                flickr: this.$store.state.lastAlbum.flickr,

                query: this.$route.query,
            };
        },

        mounted() {
            this.init();
        },

        methods: {
            init() {
                if (Number(this.id) !== Number(this.$store.state.lastAlbum.id)) {
                    this.images = [];
                    this.$mediaApi.call('getAlbum', {id: this.id}, (res) => {
                        this.date = res.date;
                        this.title = res.title;
                        this.images = res.images;
                        this.credits = res.credits;
                        this.flickr = res.flickr;
                        this.$store.commit('setLastAlbum', res);

                        // needs to be triggered after the images are available
                        if (this.$route.params.img) {
                            jQuery(($) => {
                                setTimeout(() => { // :'(
                                    $.fancybox($('.fancybox'), this.getFancyBoxOptions(this.$route.params.img-1));
                                }, 1000);
                            });
                        }
                    });
                }
            },

            /**
             * Reusable fancybox options
             *
             * @param {Number} index
             *
             * @returns {Object}
             */
            getFancyBoxOptions(index = 0) {
                return {
                    index,
                    afterLoad: (current, previous) => {
                        this.$router.push({ name: 'album-img', params: { img: current.index+1 } });
                    },
                    afterClose: () => {
                        this.$router.push({ name: 'album', query: this.query });
                    },
                };
            },
        },

        /* Route Guards for fancybox triggers */
        beforeRouteUpdate(to, from, next) {
            next();
            /*
            setTimeout(() => { // :'(
                if ($.fancybox.current.index !== to.params.img-1) {
                    $.fancybox.jumpto(to.params.img-1);
                }
            }, 100);
            */
        },
        beforeRouteEnter(to, from, next) {
            next((vm) => {
                if (to.name === 'album-img') {
                    if (!$.fancybox.current) {
                        $.fancybox($('.fancybox'), vm.getFancyBoxOptions(to.params.img-1));
                    }
                }
            });
        },
        beforeRouteLeave(to, from, next) {
            next();
            if (to.name === 'album') {
                $.fancybox.close();
            }
        }
    };
</script>

<style lang="scss">
    .album {
        line-height: 1em !important;

        .back-button {
            text-decoration: none;
            color: inherit;
            cursor: pointer;
        }

        &__link {
            display: inline-block;
            margin-right: 3px !important;
            margin-bottom: 1px !important;
            padding: 0;
        }

        &__img {
            width: 125px;
            height: 125px;
            transition: opacity 0.3s;

            &:hover {
                opacity: 0.8;
            }
        }
    }
</style>
